// VierDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "math.h"
#include "Vier.h"
#include "VierDlg.h"
#include "Eingabe.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVierDlg Dialogfeld

CVierDlg::CVierDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVierDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVierDlg)
	m_Zug = _T("");
	m_Zuege = 0;
	m_LetzterZug = _T("");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVierDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVierDlg)
	DDX_Text(pDX, IDC_EDIT, m_Zug);
	DDV_MaxChars(pDX, m_Zug, 2);
	DDX_Text(pDX, IDC_ZUEGE, m_Zuege);
	DDX_Text(pDX, IDC_LETZTERZUG, m_LetzterZug);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVierDlg, CDialog)
	//{{AFX_MSG_MAP(CVierDlg)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_BUTTON_NEU, OnButtonNeu)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVierDlg Nachrichten-Handler

BOOL CVierDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen

	// Ausgangssituation festlegen
	strOriginalLinks = "SWSWSWSWSWSWSRRGRWS";
	strOriginalRechts = "GGRRRRGSGGGGGRWSRRW";
	strZielLinks = "GGGGGGGGGSSSSSSSSSS";
	strZielRechts = "WWWWWWWWWRRRRRRRRRR";
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}


// Ringe zeichnen

void CVierDlg::OnPaint() 
{
	CPaintDC dc(this); // Gertekontext fr Zeichnen

	// Farben als Konstanten definieren
	const cRot = RGB(255,0,0);
	const cGelb = RGB(255,255,0);
	const cSchwarz = RGB(0,0,0);
	const cGrau = RGB(230,230,230);

	// Ringfarben erstellen
	CPen penRot(PS_SOLID, 3, cRot);
	CPen penGelb(PS_SOLID, 3, cGelb);
	CPen penSchwarz(PS_SOLID, 3, cSchwarz);
	CPen penGrau(PS_SOLID, 3, cGrau);

	// Fllfarben erstellen
	CBrush brushRot(cRot);
	CBrush brushGelb(cGelb);
	CBrush brushSchwarz(cSchwarz);
	CBrush brushGrau(cGrau);

	// Ring-/Kugelausmae
	const cRingRadius = 100;
	const cKugelRadius = 14;

	// Linken Ring zeichnen
	for (int nLauf = 0; nLauf<19; nLauf++)
	{
		// Ringfarbe bestimmen
		switch (strZielLinks[nLauf])
		{
		case 'R': dc.SelectObject(&penRot); break;
		case 'S': dc.SelectObject(&penSchwarz); break;
		case 'W': dc.SelectObject(&penGrau); break;
		case 'G': dc.SelectObject(&penGelb); break;
		}

		// Fllfarbe bestimmen
		switch (strOriginalLinks[nLauf])
		{
		case 'R': dc.SelectObject(&brushRot); break;
		case 'S': dc.SelectObject(&brushSchwarz); break;
		case 'W': dc.SelectObject(&brushGrau); break;
		case 'G': dc.SelectObject(&brushGelb); break;
		}
			
		// Winkel errechnen, Verdrehung beachten
		double dWinkel = -(nLauf+8.5)*3.1415926/10;
		int x,y;
		// Kugelmittelpunkt errechnen
		x = cRingRadius+20-(int)(sin(dWinkel)*cRingRadius);
		y = cRingRadius+20-(int)(cos(dWinkel)*cRingRadius);

		// Kugel zeichnen
		dc.Ellipse(x-cKugelRadius,y-cKugelRadius,
		           x+cKugelRadius,y+cKugelRadius);
	}

	// Rechten Ring zeichnen
	for (nLauf = 0; nLauf<19; nLauf++)
	{
		// Ringfarbe bestimmen
		switch (strZielRechts[nLauf])
		{
		case 'R': dc.SelectObject(&penRot); break;
		case 'S': dc.SelectObject(&penSchwarz); break;
		case 'W': dc.SelectObject(&penGrau); break;
		case 'G': dc.SelectObject(&penGelb); break;
		}

		// Fllfarbe bestimmen
		switch (strOriginalRechts[nLauf])
		{
		case 'R': dc.SelectObject(&brushRot); break;
		case 'S': dc.SelectObject(&brushSchwarz); break;
		case 'W': dc.SelectObject(&brushGrau); break;
		case 'G': dc.SelectObject(&brushGelb); break;
		}
			
		// Winkel errechnen, Verdrehung beachten
		double dWinkel = -(nLauf+18.5)*3.1415926/10;
		int x,y;
		// Kugelmittelpunkt errechnen
		x = 3*cRingRadius-40-(int)(sin(dWinkel)*cRingRadius);
		y = cRingRadius+20-(int)(cos(dWinkel)*cRingRadius);

		// Kugel zeichnen
		dc.Ellipse(x-cKugelRadius,y-cKugelRadius,
		           x+cKugelRadius,y+cKugelRadius);
	}
}


// Neue Ringe erstellen

void CVierDlg::OnButtonNeu() 
{
	// Dialog statisch erzeugen
	CEingabe Eingabe;
	
	// bisherige Ringe bergeben
	Eingabe.m_OriginalLinks = strOriginalLinks;
	Eingabe.m_OriginalRechts = strOriginalRechts;
	Eingabe.m_ZielLinks = strZielLinks;
	Eingabe.m_ZielRechts = strZielRechts;

	// Dialog ausfhren
	Eingabe.DoModal();

	// neue Ringe holen
	strOriginalLinks = Eingabe.m_OriginalLinks;
	strOriginalRechts = Eingabe.m_OriginalRechts;
	strZielLinks = Eingabe.m_ZielLinks;
	strZielRechts = Eingabe.m_ZielRechts;

	// Zuganzahl initialisieren
	m_Zuege = 0;
	UpdateData(false);

	// Ringe neu zeichnen
	Invalidate();
}


// Zug ausfhren

void CVierDlg::OnOK() 
{
	// Daten holen
	UpdateData(true);

	// auf richtige Zuglnge achten
	if (m_Zug.GetLength()==2)
	{
		// letzten Zug fr Anzeige sichern
		m_LetzterZug = m_Zug;

		// Drehweite ermitteln
		int nKugeln = atoi(m_Zug);

		// ist der linke Ring gemeint ?
		if ((m_Zug[0]=='+')||(m_Zug[0]=='-'))
			DrehLinkenRing(nKugeln);

		// rechter Ring im Uhrzeigersinn
		if (m_Zug[1]=='+')
			DrehRechtenRing(nKugeln);
		// rechter Ring entgegen Uhrzeigersinn
		if (m_Zug[1]=='-')
			DrehRechtenRing(-nKugeln);

		// Anzahl Zge um 1 erhhen
		m_Zuege++;
		// Zugeingabefeld lschen
		m_Zug = "";

		// Daten an Dialog bermitteln
		UpdateData(false);

		// Ringe neu zeichnen
		Invalidate();
	}
}


// Programmende

void CVierDlg::OnCancel() 
{
	// Ziel erreicht ?
	if ((strOriginalLinks==strZielLinks)&&
		(strOriginalRechts==strZielRechts))
	{
		CString strAusgabe;

		// Zuganzahl auslesen
		UpdateData();
		// Erfolgsmeldung
		strAusgabe.Format("Ziel nach %i Zgen erreicht.", m_Zuege);
		AfxMessageBox(strAusgabe);
	}
	else
		// Fehlmeldung
		AfxMessageBox("Ziel nicht erreicht.");
	
	// Programm beenden
	CDialog::OnCancel();
}


// rechten Ring drehen

void CVierDlg::DrehRechtenRing(int nKugeln)
{
	// negative Drehweiten in positive umsetzen
	if (nKugeln<0)
		nKugeln += 20;
	
	// schrittweise drehen
	for (int nSchritt = 0; nSchritt<nKugeln; nSchritt++)
	{
		// Schnittkugel speichern
		char chTemp = strOriginalRechts[18];
		// den Rest drehen
		for (int nLauf = 18; nLauf>0; nLauf--)
			strOriginalRechts.SetAt(nLauf, strOriginalRechts[nLauf-1]);

		// Schnittkugel aktualisieren
		strOriginalRechts.SetAt(0, strOriginalLinks[14]);
		strOriginalLinks.SetAt(14, chTemp);
	}
}


// linken Ring drehen

void CVierDlg::DrehLinkenRing(int nKugeln)
{
	// negative Drehweiten in positive umsetzen
	if (nKugeln<0)
		nKugeln += 20;
	
	// schrittweise drehen
	for (int nSchritt = 0; nSchritt<nKugeln; nSchritt++)
	{
		// Schnittkugel speichern
		char chTemp = strOriginalLinks[18];
		// den Rest drehen
		for (int nLauf = 18; nLauf>0; nLauf--)
			strOriginalLinks.SetAt(nLauf, strOriginalLinks[nLauf-1]);

		// Schnittkugel aktualisieren
		strOriginalLinks.SetAt(0, strOriginalRechts[14]);
		strOriginalRechts.SetAt(14, chTemp);
	}
}